Bug 712482

Summary: poor documentation/configurability of the tigervnc-server-module
Product: [Fedora] Fedora Reporter: John Sullivan <jsrhbz>
Component: tigervncAssignee: Adam Tkac <atkac>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 18CC: atkac, grier, joshua, ovasik, steve
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-03-20 17:31:16 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description John Sullivan 2011-06-10 14:20:31 EDT
Just managed to get this working on two machines:

1) An older desktop, which has been continuously upgraded since FC4 (now F14) and has been through various different graphics cards/drivers: onboard Intel with built-in driver, binary nVidia, binary ATI, back to binary nVidia, nouveau. At some point I installed tigervnc to get vncviewer, which must have pulled in the tigervnc-server-module package as well. At about the ATI stage, it appears that "Xorg -configure" was used to (re)generate /etc/X11/xorg.conf, though this system has always had one, which afterwards contained a "Load vnc" statement in the "Module" section since -configure appears to just enumerate all available extensions, and a "Screen" section describing the probed desktop layout.

2) A newer laptop, which was freshly installed with F14. The default install these days appears to be not to have an xorg.conf at all, to use two xorg.conf.d directories (in /etc/X11 and /usr/share/X11) with snippets to configure individual input devices, but leave the rest of the configuration to Xorg's autoprobing. As such there are *no* explicitly configured "Module" or "Screen" sections in the available xorg configuration. I deliberately installed the tigervnc, tigervnc-server and tigervnc-server-module packages.


For (1), Xorg loads the libvnc.so module, which grabs the VNC server port, but vncviewer fails to connect to it with a message like "the VNC auth password has not been set".

For (2), Xorg does not load the module at all.

There is (just about) adequate documentation for the vncserver and Xvnc components. The Xorg module has no man page or info pages. I eventually noticed a mention in the middle of /usr/share/doc/tigervnc-1.0.90/README (from the tigervnc package, not the tigervnc-server or tigervnc-server-module) that says to configure the Xorg module you have to insert Option statements into the "Screen" section of xorg.conf using the same parameter names that Xvnc uses.

So then I could get this working easily enough on (1). The key steps are using vncpasswd to create a password file, and setting the "PasswordFile" option in xorg.conf.

(2) has the additional problem of no xorg.conf at all. Attempting to add "Module" or "Screen" sections to a snippet in xorg.conf.d disables the autoconfiguration of those sections completely and renders the X server completely broken. The only fix appears to be to use "Xorg -configure" to fix the server config into a file (thus disabling future autoconfiguration), then modify the probed Module and Screen sections to add the vnc module and PasswordFile option. Theoretically I could have enabled the extension on the X server commandline by editing /etc/gdm/custom.conf, but that stills leaves the problem of the PasswordFile option which can't be set in any other way.

Needless to say this makes straightforward installation of the VNC module impossible. Google shows there have been some blog/board requests for situation (1) (modifying existing xorg.conf), but pretty much none for situation (2) which is now the Fedora distro default.

Ideally this would work out of the box on package installation, with a control panel to set the password. At the very least there needs to be some discoverable documentation (a man page and/or the -module RPM description, not the middle of the upstream package's compilation instructions) explaining the necessary manual steps.

Further, requiring changes that defeat X autoconfiguration is clearly suboptimal. The module should have some way of loading and configuring via a xorg.conf.d snippet which interferes as little as possible with any other aspect of X configuration.

(Once it's working it's a lot more useful than vino!)
Comment 1 joshua 2012-01-30 16:11:46 EST
Just as true today for F16
Comment 2 Fedora End Of Life 2013-01-16 05:20:18 EST
This message is a reminder that Fedora 16 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 16. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '16'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 16's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 16 is end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" and open it against that version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 3 joshua 2013-01-16 10:00:37 EST
Just as true today for F18
Comment 4 Adam Tkac 2013-03-14 14:41:34 EDT
I will include sample configuration file /etc/X11/xorg.conf.d/10-libvnc.conf

You can modify this file as needed and I think it's enough to allow simple deployment of libvnc.so module.
Comment 5 Fedora Update System 2013-03-14 14:59:54 EDT
tigervnc-1.2.80-0.10.20130314svn5065.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/tigervnc-1.2.80-0.10.20130314svn5065.fc18
Comment 6 Fedora Update System 2013-03-15 21:39:58 EDT
Package tigervnc-1.2.80-0.10.20130314svn5065.fc18:
* should fix your issue,
* was pushed to the Fedora 18 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing tigervnc-1.2.80-0.10.20130314svn5065.fc18'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-3933/tigervnc-1.2.80-0.10.20130314svn5065.fc18
then log in and leave karma (feedback).
Comment 7 Fedora Update System 2013-03-20 17:31:18 EDT
tigervnc-1.2.80-0.10.20130314svn5065.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.